Index: runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionTest.java
===================================================================
--- runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionTest.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionTest.java	(working copy)
@@ -10,404 +10,12 @@
  ************************************************************************************/
 package org.jboss.tools.runtime.test;
 
-import static org.junit.Assert.assertFalse;
-import static org.junit.Assert.assertTrue;
 
-import java.io.File;
-import java.io.FilenameFilter;
-import java.io.IOException;
-import java.io.StringReader;
-import java.io.StringWriter;
-import java.util.ArrayList;
-import java.util.List;
-import java.util.Set;
-import java.util.jar.Attributes;
-import java.util.jar.JarFile;
-
-import javax.xml.parsers.DocumentBuilderFactory;
-import javax.xml.transform.Transformer;
-import javax.xml.transform.TransformerException;
-import javax.xml.transform.TransformerFactory;
-import javax.xml.transform.dom.DOMSource;
-import javax.xml.transform.stream.StreamResult;
-
-import org.eclipse.core.runtime.NullProgressMonitor;
-import org.eclipse.core.runtime.Platform;
-import org.eclipse.core.runtime.preferences.ConfigurationScope;
-import org.eclipse.wst.server.core.IRuntime;
-import org.eclipse.wst.server.core.IRuntimeType;
-import org.eclipse.wst.server.core.ServerCore;
-import org.jboss.ide.eclipse.as.core.util.IJBossToolingConstants;
-import org.jboss.tools.runtime.as.detector.IJBossRuntimePluginConstants;
-import org.jboss.tools.runtime.core.JBossRuntimeLocator;
-import org.jboss.tools.runtime.core.RuntimeCoreActivator;
-import org.jboss.tools.runtime.core.model.IRuntimeDetector;
-import org.jboss.tools.runtime.core.model.InvalidRuntimeDetector;
-import org.jboss.tools.runtime.core.model.RuntimePath;
-import org.jboss.tools.runtime.core.model.RuntimeDefinition;
-import org.jboss.tools.runtime.ui.RuntimeUIActivator;
-import org.jboss.tools.seam.core.project.facet.SeamRuntime;
-import org.jboss.tools.seam.core.project.facet.SeamRuntimeManager;
-import org.jboss.tools.seam.core.project.facet.SeamVersion;
-import org.junit.BeforeClass;
-import org.junit.Test;
-import org.osgi.framework.Bundle;
-import org.w3c.dom.Document;
-import org.w3c.dom.Element;
-import org.w3c.dom.Node;
-import org.w3c.dom.NodeList;
-import org.xml.sax.InputSource;
-
 /**
  * 
  * @author snjeza
  * 
  */
-public class RuntimeDetectionTest implements IJBossRuntimePluginConstants {
-	private final static String seamVersionAttributeName = "Seam-Version";
-
-	@BeforeClass
-	public static void create() {
-		RuntimeCoreActivator.getDefault();
-		RuntimeUIActivator.getDefault();
-		addRuntimePaths();
-		createRuntimes();
-	}
-
-	private static void addRuntimePaths() {
-		Set<RuntimePath> runtimePaths = RuntimeUIActivator.getDefault()
-				.getRuntimePaths();
-		String[] paths = { IRuntimeDetectionConstants.JBOSS_42_HOME,
-				IRuntimeDetectionConstants.JBOSS_51_HOME,
-				IRuntimeDetectionConstants.JBOSS_70_HOME,
-				IRuntimeDetectionConstants.SEAM_20_HOME,
-				IRuntimeDetectionConstants.SEAM_22_HOME,
-				IRuntimeDetectionConstants.EAP_43_HOME };
-
-		for (String path : paths) {
-			RuntimePath runtimePath = new RuntimePath(path);
-			runtimePath.setScanOnEveryStartup(false);
-			runtimePaths.add(runtimePath);
-		}
-		RuntimeUIActivator.getDefault().saveRuntimePaths();
-		List<RuntimeDefinition> serverDefinitions = new ArrayList<RuntimeDefinition>();
-		Set<IRuntimeDetector> detectors = RuntimeCoreActivator
-				.getRuntimeDetectors();
-		for (IRuntimeDetector detector : detectors) {
-			if (detector.isEnabled()) {
-				detector.initializeRuntimes(serverDefinitions);
-			}
-		}
-	}
-
-	private static void createRuntimes() {
-		JBossRuntimeLocator locator = new JBossRuntimeLocator();
-		Set<RuntimePath> runtimePaths = RuntimeUIActivator.getDefault()
-				.getRuntimePaths();
-		for (RuntimePath runtimePath : runtimePaths) {
-			List<RuntimeDefinition> serverDefinitions = locator
-					.searchForRuntimes(runtimePath.getPath(),
-							new NullProgressMonitor());
-			runtimePath.getServerDefinitions().clear();
-			for (RuntimeDefinition serverDefinition : serverDefinitions) {
-				serverDefinition.setRuntimePath(runtimePath);
-			}
-			runtimePath.getServerDefinitions().addAll(serverDefinitions);
-		}
-		List<RuntimeDefinition> serverDefinitions = RuntimeUIActivator
-				.getDefault().getServerDefinitions();
-		Set<IRuntimeDetector> detectors = RuntimeCoreActivator
-				.getRuntimeDetectors();
-		for (IRuntimeDetector detector : detectors) {
-			if (detector.isEnabled()) {
-				detector.initializeRuntimes(serverDefinitions);
-			}
-		}
-	}
-
-	@Test
-	public void testRuntimeDetectors() {
-		Set<IRuntimeDetector> detectors = RuntimeCoreActivator
-				.getRuntimeDetectors();
-		assertTrue("Runtime detectors don't exist.", detectors.size() > 0);
-	}
-
-	@Test
-	public void testRuntimePaths() {
-		Set<RuntimePath> runtimePaths = RuntimeUIActivator.getDefault()
-				.getRuntimePaths();
-		assertTrue(
-				"runtimePaths.size()\nExpected: 6\nWas: " + runtimePaths.size(),
-				runtimePaths.size() == 6);
-	}
-	
-	@Test
-	public void testRuntimePathsExists() {
-		Set<RuntimePath> runtimePaths = RuntimeUIActivator.getDefault()
-				.getRuntimePaths();
-		for (RuntimePath runtimePath:runtimePaths) {
-			String path = runtimePath.getPath();
-			File file = new File(path);
-			assertTrue("The '" + file.getAbsolutePath()
-					+ "' path isn't valid.", file.isDirectory());
-		}
-	}
-
-	@Test
-	public void testLocations() {
-		List<RuntimeDefinition> serverDefinitions = RuntimeUIActivator
-				.getDefault().getServerDefinitions();
-		for (RuntimeDefinition serverDefinition : serverDefinitions) {
-			File location = serverDefinition.getLocation();
-			assertTrue("The '" + location.getAbsolutePath()
-					+ "' path isn't valid.", location.isDirectory());
-		}
-	}
-	
-	@Test
-	public void testSeam22Location() throws Exception {
-		String seamHome = IRuntimeDetectionConstants.SEAM_22_HOME;
-		testSeamHome(seamHome, "2.2");
-	}
-	
-	@Test
-	public void testSeam20Location() throws Exception {
-		String seamHome = IRuntimeDetectionConstants.SEAM_20_HOME;
-		testSeamHome(seamHome, "2.0");
-	}
-
-	private void testSeamHome(String seamHome, String seamVersion) throws IOException {
-		File file = new File(seamHome);
-		assertTrue("The '" + file.getAbsolutePath()
-				+ "' path isn't valid.", file.isDirectory());
-		String[] seamFiles = file.list(new FilenameFilter() {
-			
-			public boolean accept(File dir, String name) {
-				if ("seam-gen".equals(name)) {
-					return true;
-				}
-				if ("lib".equals(name)) {
-					return true;
-				}
-				return false;
-			}
-		});
-		assertTrue("seamFiles : " + seamFiles, seamFiles != null
-				&& seamFiles.length == 2);
-		File jarFile = new File(seamHome, "lib/jboss-seam.jar");
-		assertTrue("The '" + jarFile.getAbsolutePath() + "' path isn't valid.",
-				jarFile.isFile());
-		JarFile jar = new JarFile(jarFile);
-		Attributes attributes = jar.getManifest().getMainAttributes();
-		String version = attributes.getValue(seamVersionAttributeName);
-		assertTrue("seamVersion: " + version, version != null && version.startsWith(seamVersion));
-	}
-	
-	@Test
-	public void testServerDefinitions() {
-		List<RuntimeDefinition> serverDefinitions = RuntimeUIActivator
-				.getDefault().getServerDefinitions();
-		Set<RuntimePath> runtimePaths = RuntimeUIActivator.getDefault()
-			.getRuntimePaths();
-		assertTrue("serverDefinitions.size()\nExpected: 6\nWas: "
-				+ serverDefinitions.size() + 
-				"\nserverDefinitions: " + serverDefinitions +
-				"\nruntimePaths=" + runtimePaths, serverDefinitions.size() == 6);
-	}
-
-	@Test
-	public void testSeam22() {
-		SeamRuntime[] seamRuntimes = SeamRuntimeManager.getInstance()
-				.getRuntimes();
-		int count = 0;
-		for (SeamRuntime seamRuntime : seamRuntimes) {
-			SeamVersion version = seamRuntime.getVersion();
-			if (SeamVersion.SEAM_2_2.equals(version)) {
-				count++;
-			}
-		}
-		assertTrue("Seam 2.2\nExpected: 1\nWas: " + count, count == 1);
-	}
-
-	@Test
-	public void testSeam20() {
-		SeamRuntime[] seamRuntimes = SeamRuntimeManager.getInstance()
-				.getRuntimes();
-		int count = 0;
-		for (SeamRuntime seamRuntime : seamRuntimes) {
-			SeamVersion version = seamRuntime.getVersion();
-			if (SeamVersion.SEAM_2_0.equals(version)) {
-				count++;
-			}
-		}
-		assertTrue("Seam 2.0\nExpected: 2\nWas: " + count, count == 2);
-	}
-
-	@Test
-	public void testSeam12() {
-		SeamRuntime[] seamRuntimes = SeamRuntimeManager.getInstance()
-				.getRuntimes();
-		int count = 0;
-		for (SeamRuntime seamRuntime : seamRuntimes) {
-			SeamVersion version = seamRuntime.getVersion();
-			if (SeamVersion.SEAM_1_2.equals(version)) {
-				count++;
-			}
-		}
-		assertTrue("Seam 1.2\nExpected: 1\nWas: " + count, count == 1);
-	}
-
-	@Test
-	public void testSeamRuntimes() {
-		SeamRuntime[] seamRuntimes = SeamRuntimeManager.getInstance()
-				.getRuntimes();
-		assertTrue("seamRuntimes.length\nExpected: 4\nWas: "
-				+ seamRuntimes.length, seamRuntimes.length == 4);
-	}
-
-	@Test
-	public void testJBossAs42() {
-		IRuntime[] runtimes = ServerCore.getRuntimes();
-		int count = 0;
-		for (IRuntime runtime : runtimes) {
-			IRuntimeType runtimeType = runtime.getRuntimeType();
-			if (IJBossToolingConstants.AS_42.equals(runtimeType.getId())) {
-				count++;
-			}
-		}
-		assertTrue("JBoss AS 4.2\nExpected: 1\nWas: " + count, count == 1);
-	}
-
-	@Test
-	public void testJBossAs51() {
-		IRuntime[] runtimes = ServerCore.getRuntimes();
-		int count = 0;
-		for (IRuntime runtime : runtimes) {
-			IRuntimeType runtimeType = runtime.getRuntimeType();
-			if (IJBossToolingConstants.AS_51.equals(runtimeType.getId())) {
-				count++;
-			}
-		}
-		assertTrue("JBoss AS 5.1\nExpected: 1\nWas: " + count, count == 1);
-	}
-	
-	@Test
-	public void testJBossAs70() {
-		IRuntime[] runtimes = ServerCore.getRuntimes();
-		int count = 0;
-		for (IRuntime runtime : runtimes) {
-			IRuntimeType runtimeType = runtime.getRuntimeType();
-			if (IJBossToolingConstants.AS_70.equals(runtimeType.getId())) {
-				count++;
-			}
-		}
-		assertTrue("JBoss AS 7.0\nExpected: 1\nWas: " + count, count == 1);
-	}
-
-	@Test
-	public void testJBossEap43() {
-		IRuntime[] runtimes = ServerCore.getRuntimes();
-		int count = 0;
-		for (IRuntime runtime : runtimes) {
-			IRuntimeType runtimeType = runtime.getRuntimeType();
-			if (IJBossToolingConstants.EAP_43.equals(runtimeType.getId())) {
-				count++;
-			}
-		}
-		assertTrue("JBoss EAP 4.3\nExpected: 1\nWas: " + count, count == 1);
-	}
-
-	@Test
-	public void testWtpRuntimes() {
-		IRuntime[] runtimes = ServerCore.getRuntimes();
-		assertTrue("runtimes.length\nExpected: 4\nWas: " + runtimes.length,
-				runtimes.length == 4);
-	}
-	
-	@Test
-	public void testIncludedDefinitions() {
-		for (RuntimeDefinition serverDefinition:RuntimeUIActivator.getDefault().getServerDefinitions()){
-			String type = serverDefinition.getType();
-			if (EAP.equals(type)) {
-				assertTrue("EAP has to include server definitions", serverDefinition.getIncludedServerDefinitions().size() > 0);
-				for(RuntimeDefinition included:serverDefinition.getIncludedServerDefinitions()) {
-					assertTrue("Invalid parent definition", included.getParent() == serverDefinition);
-				}
-			}
-		}
-	}
-	
-	@Test
-	public void testSavePreferences() throws Exception {
-		// saves preferences
-		Bundle bundle = Platform.getBundle(RuntimeUIActivator.PLUGIN_ID);
-		bundle.stop();
-		// loads preferences
-		bundle.start();
-		// calls tests again
-		testServerDefinitions();
-		testIncludedDefinitions();
-		testRuntimePaths();
-		testRuntimeDetectors();
-		testLocations();
-		testSeamRuntimes();
-		testWtpRuntimes();
-		testSeam22();
-		testSeam22Location();
-	}
-	
-	@Test
-	public void testOldWorkspace() throws Exception {
-		String runtimes = ConfigurationScope.INSTANCE.getNode(
-				RuntimeUIActivator.PLUGIN_ID).get(
-				RuntimeUIActivator.RUNTIME_PATHS, null);
-		// removes version and included definitions
-		DocumentBuilderFactory factory = DocumentBuilderFactory.newInstance();
-	    Document doc = factory.newDocumentBuilder().parse(new InputSource(new StringReader(runtimes)));
-		Element runtimePaths = (Element) doc.getElementsByTagName(RuntimeUIActivator.RUNTIME_PATHS).item(0);
-		runtimePaths.removeAttribute(RuntimeUIActivator.PREFERENCES_VERSION);
-		removeIncluded(doc);
-		runtimes = serialize(doc);
-	    // restarts the bundle
-		Bundle bundle = Platform.getBundle(RuntimeUIActivator.PLUGIN_ID);
-		bundle.stop();
-		bundle.start();
-		// saves preferences
-		ConfigurationScope.INSTANCE.getNode(RuntimeUIActivator.PLUGIN_ID).put(
-				RuntimeUIActivator.RUNTIME_PATHS, runtimes);
-		// calls tests again 
-		testIncludedDefinitions();
-		testServerDefinitions();
-	}
-	
-	private void removeIncluded(Node node) {
-		if (node.getNodeType() == Node.ELEMENT_NODE
-				&& node.getNodeName().equals("included")) {
-			node.getParentNode().removeChild(node);
-		} else {
-			NodeList list = node.getChildNodes();
-			for (int i = 0; i < list.getLength(); i++) {
-				removeIncluded(list.item(i));
-			}
-		}
-	}
-	
-	@Test
-	public void testInvalidDetectors() {
-		Set<IRuntimeDetector> detectors = RuntimeCoreActivator.getDeclaredRuntimeDetectors();
-		IRuntimeDetector invalidDetector = null;
-		for (IRuntimeDetector detector:detectors) {
-			if (detector instanceof InvalidRuntimeDetector) {
-				invalidDetector = detector;
-			}
-		}
-		assertFalse("Invalid detector is enabled.", invalidDetector.isEnabled());
-	}
-	
-	private String serialize(Document doc) throws TransformerException {
-		StringWriter stringWriter = new StringWriter(); 
-		Transformer serializer = TransformerFactory.newInstance().newTransformer();
-        serializer.transform(new DOMSource(doc), new StreamResult(stringWriter));
-        return stringWriter.toString(); 
-	}
+public class RuntimeDetectionTest {
+	// Logic moved to seam tests
 }
Index: runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionAllTests.java
===================================================================
--- runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionAllTests.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 43315)
+++ runtime/tests/org.jboss.tools.runtime.test/src/org/jboss/tools/runtime/test/RuntimeDetectionAllTests.java	(working copy)
@@ -15,7 +15,7 @@
 
 
 @Suite.SuiteClasses({
-	RuntimeDetectionTest.class,
+	RuntimeDetectionFrameworkTest.class
 })
 
 @RunWith(Suite.class)
Index: seam/features/org.jboss.tools.runtime.seam.detector.feature/.project
===================================================================
--- seam/features/org.jboss.tools.runtime.seam.detector.feature/.project	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/features/org.jboss.tools.runtime.seam.detector.feature/.project	(working copy)
@@ -0,0 +1,17 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>org.jboss.tools.runtime.seam.detector.feature</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.pde.FeatureBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.pde.FeatureNature</nature>
+	</natures>
+</projectDescription>
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/.project
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/.project	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/.project	(working copy)
@@ -0,0 +1,28 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<projectDescription>
+	<name>org.jboss.tools.runtime.seam.detector</name>
+	<comment></comment>
+	<projects>
+	</projects>
+	<buildSpec>
+		<buildCommand>
+			<name>org.eclipse.jdt.core.javabuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.pde.ManifestBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+		<buildCommand>
+			<name>org.eclipse.pde.SchemaBuilder</name>
+			<arguments>
+			</arguments>
+		</buildCommand>
+	</buildSpec>
+	<natures>
+		<nature>org.eclipse.pde.PluginNature</nature>
+		<nature>org.eclipse.jdt.core.javanature</nature>
+	</natures>
+</projectDescription>
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/about.mappings
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/about.mappings	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/about.mappings	(working copy)
@@ -0,0 +1,5 @@
+# about.mappings
+# contains fill-ins for about.properties
+# java.io.Properties file (ISO 8859-1 with "\" escapes)
+# This file does not need to be translated.
+
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/src/org/jboss/tools/runtime/handlers/SeamHandler.java
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/src/org/jboss/tools/runtime/handlers/SeamHandler.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/src/org/jboss/tools/runtime/handlers/SeamHandler.java	(working copy)
@@ -0,0 +1,184 @@
+/*************************************************************************************
+ * Copyright (c) 2010-2011 Red Hat, Inc. and others.
+ * All rights reserved. This program and the accompanying materials 
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ * 
+ * Contributors:
+ *     JBoss by Red Hat - Initial implementation.
+ ************************************************************************************/
+package org.jboss.tools.runtime.handlers;
+
+import java.io.File;
+import java.io.FilenameFilter;
+import java.io.IOException;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+import java.util.jar.Attributes;
+import java.util.jar.JarFile;
+
+import org.eclipse.core.runtime.IProgressMonitor;
+import org.jboss.tools.runtime.core.model.AbstractRuntimeDetector;
+import org.jboss.tools.runtime.core.model.RuntimeDefinition;
+import org.jboss.tools.seam.core.SeamUtil;
+import org.jboss.tools.seam.core.project.facet.SeamRuntime;
+import org.jboss.tools.seam.core.project.facet.SeamRuntimeManager;
+import org.jboss.tools.seam.core.project.facet.SeamVersion;
+
+public class SeamHandler extends AbstractRuntimeDetector {
+
+	private final static String seamJarName = "jboss-seam.jar";
+	private final static String seamVersionAttributeName = "Seam-Version";
+	private static final String SEAM = "SEAM"; // NON-NLS-1$
+	
+	private static File getSeamRoot(RuntimeDefinition serverDefinition) {
+		String type = serverDefinition.getType();
+		if (SEAM.equals(type)) {
+			return serverDefinition.getLocation();
+		}
+		return null;
+	}
+	
+	@Override
+	public void initializeRuntimes(List<RuntimeDefinition> serverDefinitions) {
+		
+		Map<String, SeamRuntime> map = new HashMap<String,SeamRuntime>();
+
+		for(RuntimeDefinition serverDefinition:serverDefinitions) {
+			if (serverDefinition.isEnabled()) {
+				String type = serverDefinition.getType();
+				if (SEAM.equals(type)) {
+					addSeam(map, serverDefinition,
+							serverDefinition.getLocation());
+				}
+			}
+			initializeRuntimes(serverDefinition.getIncludedServerDefinitions());
+		}
+		SeamRuntimeManager.getInstance().save();
+	}
+
+	private static void addSeam(Map<String, SeamRuntime> map,
+			RuntimeDefinition serverDefinition, File seamFile) {
+		if (seamFile.exists() && seamFile.canRead() && seamFile.isDirectory()) {
+			SeamVersion seamVersion = getSeamVersion(seamFile.getAbsolutePath());
+			if (seamVersion != null) {
+				String name = "Seam " + serverDefinition.getName() + " " + seamVersion; //$NON-NLS-1$ //$NON-NLS-2$
+				addSeam(map, seamFile.getAbsolutePath(), seamVersion, name);
+			}
+		}
+	}
+
+	private static void addSeam(Map<String, SeamRuntime> map, String seamPath,SeamVersion seamVersion, String name) {
+		if (!seamExists(seamPath)) {
+			File seamFolder = new File(seamPath);
+			if(seamFolder.exists() && seamFolder.isDirectory()) {
+				SeamRuntime rt = new SeamRuntime();
+				rt.setHomeDir(seamPath);
+				rt.setName(name);
+				rt.setDefault(true);
+				rt.setVersion(seamVersion);
+				SeamRuntimeManager.getInstance().addRuntime(rt);
+			}
+		}
+	}
+
+	private static SeamVersion getSeamVersion(String seamGenBuildPath) {
+		if (seamGenBuildPath == null || seamGenBuildPath.trim().length() <= 0) {
+			return null;
+		}
+		String fullVersion = SeamUtil.getSeamVersionFromManifest(seamGenBuildPath);
+		if (fullVersion == null) {
+			return null;	
+		}
+		String version = fullVersion.substring(0,3);
+		SeamVersion seamVersion = null;
+		if (version != null) {
+			seamVersion = SeamVersion.findByString(version);
+		}
+		return seamVersion;
+	}
+	
+	/**
+	 * @param seamPath
+	 * @return
+	 */
+	private static boolean seamExists(String seamPath) {
+		SeamRuntime[] seamRuntimes = SeamRuntimeManager.getInstance().getRuntimes();
+		for (SeamRuntime sr:seamRuntimes) {
+			if (seamPath != null && seamPath.equals(sr.getHomeDir())) {
+				return true;
+			}
+		}
+		return false;
+	}
+
+	@Override
+	public RuntimeDefinition getServerDefinition(File root,
+			IProgressMonitor monitor) {
+		if (monitor.isCanceled() || root == null) {
+			return null;
+		}
+		String seamVersion = getSeamVersionFromManifest(root.getAbsolutePath());
+		if (seamVersion != null) {
+			return new RuntimeDefinition(root.getName(), seamVersion, SEAM, root.getAbsoluteFile());
+		}
+		return null;
+	}
+
+	private static String getSeamVersionFromManifest(String seamHome) {
+		File seamHomeFolder = new File(seamHome);
+		if (seamHomeFolder == null || !seamHomeFolder.isDirectory()) {
+			return null;
+		}
+		String[] seamFiles = seamHomeFolder.list(new FilenameFilter() {
+			
+			public boolean accept(File dir, String name) {
+				if ("seam-gen".equals(name)) {
+					return true;
+				}
+				if ("lib".equals(name)) {
+					return true;
+				}
+				return false;
+			}
+		});
+		if (seamFiles == null || seamFiles.length != 2) {
+			return null;
+		}
+		File jarFile = new File(seamHome, "lib/" + seamJarName);
+		if(!jarFile.isFile()) {
+			jarFile = new File(seamHome, seamJarName);
+			if(!jarFile.isFile()) {
+				return null;
+			}
+		}
+		try {
+			JarFile jar = new JarFile(jarFile);
+			Attributes attributes = jar.getManifest().getMainAttributes();
+			String version = attributes.getValue(seamVersionAttributeName);
+			if (version == null) {
+				// Seam 2.3
+				version = attributes.getValue("Implementation-Version");
+			}
+			return version;
+		} catch (IOException e) {
+			return null;
+		}
+	}
+
+	@Override
+	public boolean exists(RuntimeDefinition serverDefinition) {
+		if (serverDefinition == null || serverDefinition.getLocation() == null) {
+			return false;
+		}
+		File seamRoot = getSeamRoot(serverDefinition);
+		if (seamRoot == null || !seamRoot.isDirectory()) {
+			return false;
+		}
+		String path = seamRoot.getAbsolutePath();
+		return seamExists(path);
+	}
+
+}
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/src/org/jboss/tools/runtime/seam/detector/RuntimeSeamActivator.java
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/src/org/jboss/tools/runtime/seam/detector/RuntimeSeamActivator.java	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/src/org/jboss/tools/runtime/seam/detector/RuntimeSeamActivator.java	(working copy)
@@ -0,0 +1,73 @@
+/*******************************************************************************
+ * Copyright (c) 2011 Red Hat, Inc.
+ * Distributed under license by Red Hat, Inc. All rights reserved.
+ * This program is made available under the terms of the
+ * Eclipse Public License v1.0 which accompanies this distribution,
+ * and is available at http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     Red Hat, Inc. - initial API and implementation
+ ******************************************************************************/
+
+package org.jboss.tools.runtime.seam.detector;
+
+import org.eclipse.core.runtime.IStatus;
+import org.eclipse.core.runtime.Status;
+import org.eclipse.ui.plugin.AbstractUIPlugin;
+import org.osgi.framework.BundleContext;
+
+/**
+ * The activator class controls the plug-in life cycle
+ */
+public class RuntimeSeamActivator extends AbstractUIPlugin {
+
+	// The plug-in ID
+	public static final String PLUGIN_ID = "org.jboss.tools.runtime.seam.detector"; //$NON-NLS-1$
+
+	// The shared instance
+	private static RuntimeSeamActivator plugin;
+	
+	/**
+	 * The constructor
+	 */
+	public RuntimeSeamActivator() {
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#start(org.osgi.framework.BundleContext)
+	 */
+	public void start(BundleContext context) throws Exception {
+		super.start(context);
+		plugin = this;
+	}
+
+	/*
+	 * (non-Javadoc)
+	 * @see org.eclipse.ui.plugin.AbstractUIPlugin#stop(org.osgi.framework.BundleContext)
+	 */
+	public void stop(BundleContext context) throws Exception {
+		plugin = null;
+		super.stop(context);
+	}
+
+	/**
+	 * Returns the shared instance
+	 *
+	 * @return the shared instance
+	 */
+	public static RuntimeSeamActivator getDefault() {
+		return plugin;
+	}
+
+	public static void log(Throwable e) {
+		IStatus status = new Status(IStatus.ERROR, PLUGIN_ID, e
+				.getLocalizedMessage(), e);
+		getDefault().getLog().log(status);
+	}
+	
+	public static void log(Throwable e, String message) {
+		IStatus status = new Status(IStatus.ERROR, PLUGIN_ID, message, e);
+		getDefault().getLog().log(status);
+	}
+}
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/about.ini
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/about.ini	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/about.ini	(working copy)
@@ -0,0 +1,27 @@
+# about.ini
+# contains information about a feature
+# java.io.Properties file (ISO 8859-1 with "\" escapes)
+# "%key" are externalized strings defined in about.properties
+# This file does not need to be translated.
+# test
+# Property "aboutText" contains blurb for "About" dialog (translated)
+aboutText=%blurb
+
+# Property "windowImage" contains path to window icon (16x16)
+# needed for primary features only
+
+# Property "featureImage" contains path to feature image (32x32)
+featureImage=jboss_about.png
+
+# Property "aboutImage" contains path to product image (500x330 or 115x164)
+# needed for primary features only
+
+# Property "appName" contains name of the application (not translated)
+# needed for primary features only
+
+# Property "welcomePerspective" contains the id of the perspective in which the
+# welcome page is to be opened.
+# optional
+
+
+
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/.settings/org.eclipse.jdt.core.prefs
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/.settings/org.eclipse.jdt.core.prefs	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/.settings/org.eclipse.jdt.core.prefs	(working copy)
@@ -0,0 +1,8 @@
+#Mon May 30 13:29:40 CEST 2011
+eclipse.preferences.version=1
+org.eclipse.jdt.core.compiler.codegen.inlineJsrBytecode=enabled
+org.eclipse.jdt.core.compiler.codegen.targetPlatform=1.6
+org.eclipse.jdt.core.compiler.compliance=1.6
+org.eclipse.jdt.core.compiler.problem.assertIdentifier=error
+org.eclipse.jdt.core.compiler.problem.enumIdentifier=error
+org.eclipse.jdt.core.compiler.source=1.6
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/.classpath
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/.classpath	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/.classpath	(working copy)
@@ -0,0 +1,7 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<classpath>
+	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER/org.eclipse.jdt.internal.debug.ui.launcher.StandardVMType/JavaSE-1.6"/>
+	<classpathentry kind="con" path="org.eclipse.pde.core.requiredPlugins"/>
+	<classpathentry kind="src" path="src"/>
+	<classpathentry kind="output" path="bin"/>
+</classpath>
Index: seam/plugins/org.jboss.tools.runtime.seam.detector/META-INF/MANIFEST.MF
===================================================================
--- seam/plugins/org.jboss.tools.runtime.seam.detector/META-INF/MANIFEST.MF	(.../https://svn.jboss.org/repos/jbosstools/trunk)	(revision 0)
+++ seam/plugins/org.jboss.tools.runtime.seam.detector/META-INF/MANIFEST.MF	(working copy)
@@ -0,0 +1,39 @@
+Manifest-Version: 1.0
+Bundle-ManifestVersion: 2
+Bundle-Name: %BundleName
+Bundle-SymbolicName: org.jboss.tools.runtime.seam.detector;singleton:=true
+Bundle-Version: 3.4.0.qualifier
+Require-Bundle: org.eclipse.core.runtime,
+ org.junit;bundle-version="4.8.1",
+ org.jboss.tools.runtime.ui,
+ org.jboss.tools.runtime.core,
+ org.jboss.tools.tests,
+ org.jboss.tools.seam.core,
+ org.eclipse.datatools.connectivity,
+ org.eclipse.datatools.connectivity.db.generic,
+ org.jboss.tools.common,
+ org.jboss.tools.tests,
+ org.jboss.ide.eclipse.as.core,
+ org.eclipse.wst.server.core,
+ org.eclipse.datatools.enablement.hsqldb,
+ org.eclipse.datatools.enablement.hsqldb.dbdefinition,
+ org.eclipse.datatools.enablement.hsqldb.ui,
+ org.eclipse.jst.jee,
+ org.eclipse.jst.jee.ejb,
+ org.eclipse.jst.jee.ui,
+ org.eclipse.jst.jee.web,
+ org.eclipse.ui,
+ org.eclipse.core.resources,
+ org.jboss.tools.jsf.vpe.seam,
+ org.jboss.tools.seam.pages.xml,
+ org.jboss.tools.seam.ui,
+ org.jboss.tools.seam.ui.pages,
+ org.jboss.tools.seam.xml,
+ org.jboss.tools.seam.xml.ui,
+ org.jboss.tools.seam.text.ext,
+ org.jboss.tools.runtime.as.detector
+Bundle-ActivationPolicy: lazy
+Bundle-RequiredExecutionEnvironment: JavaSE-1.6
+Bundle-Vendor: %BundleVendor
+Bundle-Localization: plugin
+
